#version 330 core

in vec2 vTexCoords;

uniform vec4 uScale;
uniform vec4 uBias;
uniform int writeAlpha = 0;

uniform sampler2D uInputTex;
uniform sampler2D alphaTex;

out vec4 fResult;

/*----------------------------------------------------------------------------*/
void main() {
	fResult = max(vec4(0.0), texture(uInputTex, vTexCoords) + uBias) * uScale;
	if(writeAlpha == 1) 
	{	
		fResult.a = texture(alphaTex, vTexCoords).a;
	} 
}