#version 330 
layout (location = 0) in vec3 vertexPosition_modelspace;

vec4 viewportScale = vec4(1280.0,720.0,1.0,1.0);
vec4 viewportBias = vec4(-0.5,-0.5,0,0);
// Offsets 0-3 used by vertex shader, 4-6 by pixel shader
uniform float vertTapOffs[7];
out vec4 vPosition;
out vec2 vTap0;
out vec2 vTap1;
out vec2 vTap2;
out vec2 vTap3;
out vec2 vTap1Neg;
out vec2 vTap2Neg;
out vec2 vTap3Neg;

const vec2 madd = vec2(0.5,0.5);

void main()
{
   gl_Position = vec4(vertexPosition_modelspace.xy, 0.0, 1.0);
   	vec2 vTexCoords = vertexPosition_modelspace.xy * madd + madd;
	// Compute tap coordinates
	vTap0 = vTexCoords;
    vTap1 = vTexCoords + vec2(0.0, vertTapOffs[1]);
    vTap2 = vTexCoords + vec2(0.0, vertTapOffs[2]);
    vTap3 = vTexCoords + vec2(0.0, vertTapOffs[3]);
    vTap1Neg = vTexCoords - vec2(0.0, vertTapOffs[1]);
    vTap2Neg = vTexCoords - vec2(0.0, vertTapOffs[2]);
    vTap3Neg = vTexCoords - vec2(0.0, vertTapOffs[3]);
}
