#version 330 
layout (location = 0) in vec3 vertexPosition_modelspace; 
layout (location = 2) in vec3 normals;
 
uniform mat4 MVP;
uniform mat4 M;
uniform mat4 mWorldView; // transform to camera space aka modelview
uniform float fFocalDistance;
uniform float fFocalRange;

out vec3 vNormalCam; 
out vec3 vPosition;
out float fBlur; // DoF blur value,  falloff

void main()
{ 
	gl_Position =  MVP * vec4(vertexPosition_modelspace,1);
	vNormalCam = vec3(M * vec4(normals,0)); 
	vPosition = vec3(M * vec4(vertexPosition_modelspace,1)); 
	vec4 vPosWV = mWorldView * vec4(vertexPosition_modelspace,1); // to camera space, for DoF
	fBlur = clamp(abs(vPosWV.z - fFocalDistance) / fFocalRange,  0.0, 1.0);
}