#version 330 core

in vec2 vTexCoords;
uniform sampler2D sceneTex;
uniform sampler2D ssaoTex;
uniform sampler2D lensflareTex;
uniform sampler2D uLensStarTex;
uniform sampler2D uLensDirtTex;
uniform sampler2D uBlurredDoFTex;
uniform sampler2D uAlphaTex;

uniform mat4 uLensStarMatrix;
// camera rotation metric for starburst
out vec4 vColorOut;
void main(){
	vec4 color = vec4(0);
    vec4 lensMod = texture(uLensDirtTex, vTexCoords);
    vec4 ssao = texture(ssaoTex, vTexCoords);
    // glowmap
	vec4 regularScene = texture(sceneTex, vTexCoords);
    // rendered scene
	vec2 lensStarTexcoord = (uLensStarMatrix * vec4(vTexCoords, 0.0, 1.0)).xy;
	lensMod += texture(uLensStarTex, lensStarTexcoord);
    lensMod	*= vec4(vec3(7), 1.0);
    vec4 lensflare = texture(lensflareTex, vTexCoords);
    color = 2 * mix(regularScene, lensflare * lensMod, 0.5 );
	float fBlurriness = texture(uAlphaTex, vTexCoords).a;
	vColorOut = mix(color, texture(uBlurredDoFTex, vTexCoords), fBlurriness) * ssao;
	vColorOut.a = 1.0;
    //additive
	//color = dst*src;
	// Screen blending 
	//color = clamp((src + dst) - (src * dst), 0.0, 1.0);
}